# coding: utf-8

"""
    Songtradr API

    This is the Songtradr API. Use it to retrieve deep music metadata and trigger processes like auto-tagging.  You can also use the API to manage your account and musicube cloud data.  **Authentication**  1. Reach out to support@songtradr.com to receive a free account or use your login data if you are already signed up.  2. To authenticate, you need to login via the POST /api/v1/user/login endpoint.  3. The endpoint responds with a jwtToken which you can use in all following API requests as a bearer token.  **Rate Limiting**  The current limit is 120 Requests per minute. Reach out to us via support@songtradr.com if you need to request more.  **Getting Started with auto-tagging**  1. If you want to get your own files auto-tagged, use the POST /api/v1/user/file/{name}/initUpload endpoint. It responds with a presigned S3 link where you can upload your file. 2. You can check the processing status of your file via the GET /api/v1/user/file/{name}/filesStatus endpoint. 3. As soon as processing is done, you can request the generated data via the GET /api/v1/user/files endpoint.  **Getting Started with search**  You can either search the released music via the /public/recording endpoints or your own private uploaded music via the /user/file/ endpoints.  1. If you want to search the world's released music, a good starting point is the GET /api/v1/public/recording/search endpoint. Please find the extensive list of parameters that serve as semantic search filters. 2. If you want to search your own previously uploaded music, a good starting point is the GET GET /api/v1/user/files endpoint. It has the same extensive list of parameters that serve as semantic search filters.  # noqa: E501

    The version of the OpenAPI document: 1.12.24
    Contact: info@songtradr.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr

class UserDTO(BaseModel):
    """
    All details on a user.
    """
    username: StrictStr = Field(...)
    email_address: StrictStr = Field(..., alias="emailAddress")
    company_name: Optional[StrictStr] = Field(None, alias="companyName")
    is_admin: StrictBool = Field(..., alias="isAdmin")
    full_search_allowed: StrictBool = Field(..., alias="fullSearchAllowed")
    voice_search_allowed: StrictBool = Field(..., alias="voiceSearchAllowed")
    recording_detail_allowed: StrictBool = Field(..., alias="recordingDetailAllowed")
    artist_detail_allowed: StrictBool = Field(..., alias="artistDetailAllowed")
    playlist_prediction_allowed: StrictBool = Field(..., alias="playlistPredictionAllowed")
    widgets_allowed: StrictBool = Field(..., alias="widgetsAllowed")
    signup_allowed: StrictBool = Field(..., alias="signupAllowed")
    upload_allowed: StrictBool = Field(..., alias="uploadAllowed")
    fingerprint_allowed: StrictBool = Field(..., alias="fingerprintAllowed")
    audiotagging_allowed: StrictBool = Field(..., alias="audiotaggingAllowed")
    b2b_allowed: StrictBool = Field(..., alias="b2bAllowed")
    editor_allowed: StrictBool = Field(..., alias="editorAllowed")
    insights_allowed: StrictBool = Field(..., alias="insightsAllowed")
    genres_allowed: StrictBool = Field(..., alias="genresAllowed")
    moods_allowed: StrictBool = Field(..., alias="moodsAllowed")
    instrumentation_allowed: StrictBool = Field(..., alias="instrumentationAllowed")
    sound_features_allowed: StrictBool = Field(..., alias="soundFeaturesAllowed")
    tonal_features_allowed: StrictBool = Field(..., alias="tonalFeaturesAllowed")
    rhythm_features_allowed: StrictBool = Field(..., alias="rhythmFeaturesAllowed")
    audience_allowed: StrictBool = Field(..., alias="audienceAllowed")
    origin_allowed: StrictBool = Field(..., alias="originAllowed")
    quality_allowed: StrictBool = Field(..., alias="qualityAllowed")
    reduced_musical_features: StrictBool = Field(..., alias="reducedMusicalFeatures")
    confirmed: StrictBool = Field(...)
    language: StrictStr = Field(...)
    admin: Optional[StrictBool] = None
    __properties = ["username", "emailAddress", "companyName", "isAdmin", "fullSearchAllowed", "voiceSearchAllowed", "recordingDetailAllowed", "artistDetailAllowed", "playlistPredictionAllowed", "widgetsAllowed", "signupAllowed", "uploadAllowed", "fingerprintAllowed", "audiotaggingAllowed", "b2bAllowed", "editorAllowed", "insightsAllowed", "genresAllowed", "moodsAllowed", "instrumentationAllowed", "soundFeaturesAllowed", "tonalFeaturesAllowed", "rhythmFeaturesAllowed", "audienceAllowed", "originAllowed", "qualityAllowed", "reducedMusicalFeatures", "confirmed", "language", "admin"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserDTO:
        """Create an instance of UserDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserDTO:
        """Create an instance of UserDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UserDTO.parse_obj(obj)

        _obj = UserDTO.parse_obj({
            "username": obj.get("username"),
            "email_address": obj.get("emailAddress"),
            "company_name": obj.get("companyName"),
            "is_admin": obj.get("isAdmin"),
            "full_search_allowed": obj.get("fullSearchAllowed"),
            "voice_search_allowed": obj.get("voiceSearchAllowed"),
            "recording_detail_allowed": obj.get("recordingDetailAllowed"),
            "artist_detail_allowed": obj.get("artistDetailAllowed"),
            "playlist_prediction_allowed": obj.get("playlistPredictionAllowed"),
            "widgets_allowed": obj.get("widgetsAllowed"),
            "signup_allowed": obj.get("signupAllowed"),
            "upload_allowed": obj.get("uploadAllowed"),
            "fingerprint_allowed": obj.get("fingerprintAllowed"),
            "audiotagging_allowed": obj.get("audiotaggingAllowed"),
            "b2b_allowed": obj.get("b2bAllowed"),
            "editor_allowed": obj.get("editorAllowed"),
            "insights_allowed": obj.get("insightsAllowed"),
            "genres_allowed": obj.get("genresAllowed"),
            "moods_allowed": obj.get("moodsAllowed"),
            "instrumentation_allowed": obj.get("instrumentationAllowed"),
            "sound_features_allowed": obj.get("soundFeaturesAllowed"),
            "tonal_features_allowed": obj.get("tonalFeaturesAllowed"),
            "rhythm_features_allowed": obj.get("rhythmFeaturesAllowed"),
            "audience_allowed": obj.get("audienceAllowed"),
            "origin_allowed": obj.get("originAllowed"),
            "quality_allowed": obj.get("qualityAllowed"),
            "reduced_musical_features": obj.get("reducedMusicalFeatures"),
            "confirmed": obj.get("confirmed"),
            "language": obj.get("language"),
            "admin": obj.get("admin")
        })
        return _obj


